//$Id: Propagation.java,v 1.1.1.1 2006/08/29 10:01:07 guy Exp $
//$Log: Propagation.java,v $
//Revision 1.1.1.1  2006/08/29 10:01:07  guy
//Import of 3.0 essentials edition.
//
//Revision 1.1.1.1  2006/04/29 08:55:40  guy
//Initial import.
//
//Revision 1.1.1.1  2006/03/29 13:21:34  guy
//Imported.
//
//Revision 1.1.1.1  2006/03/23 16:25:29  guy
//Imported.
//
//Revision 1.1.1.1  2006/03/22 13:46:57  guy
//Import.
//
//Revision 1.2  2006/03/21 13:23:48  guy
//Introduced active recovery and CompTx properties as meta-tags.
//
//Revision 1.1.1.1  2006/03/09 14:59:22  guy
//Imported 3.0 development into CVS repository.
//
//Revision 1.4  2005/08/09 15:23:39  guy
//Updated javadoc, and redesigned CompositeTransaction interface
//(eliminated TransactionControl and CompositeTerminator).
//
//Revision 1.3  2005/08/05 15:03:28  guy
//Merged-in changes/additions of redesign-5-2004 (SOAP development branch).
//
//Revision 1.2  2004/10/12 13:03:26  guy
//Updated docs (changed Atomikos to Atomikos in many places).
//
//Revision 1.1.1.1  2001/10/09 12:37:25  guy
//Core module
//


              
/*
 * Copyright 2000-2008, Atomikos (http://www.atomikos.com) 
 *
 * This code ("Atomikos TransactionsEssentials"), by itself, 
 * is being distributed under the 
 * Apache License, Version 2.0 ("License"), a copy of which may be found at 
 * http://www.atomikos.com/licenses/apache-license-2.0.txt . 
 * You may not use this file except in compliance with the License. 
 *             
 * While the License grants certain patent license rights, 
 * those patent license rights only extend to the use of 
 * Atomikos TransactionsEssentials by itself. 
 *             
 * This code (Atomikos TransactionsEssentials) contains certain interfaces 
 * in package (namespace) com.atomikos.icatch
 * (including com.atomikos.icatch.Participant) which, if implemented, may
 * infringe one or more patents held by Atomikos.  
 * It should be appreciated that you may NOT implement such interfaces; 
 * licensing to implement these interfaces must be obtained separately from Atomikos.
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  
 */
 
package com.atomikos.icatch;
import java.util.Stack;

/**
 *
 *
 *Information to propagate a transaction to a remote server.
 *
 *
 *
 */

public interface Propagation extends java.io.Serializable 
{
    /**
     *Get the ancestor information as a stack.
     *
     *@return Stack The ancestor transactions.
     */

    public Stack getLineage();
    
    /**
     *Test if serial mode or not; if serial, no parallelism allowed.
     *
     *@return boolean True iff serial mode is set.
     */
    
    public boolean isSerial();
    
    
     /**
      *Get the timeout left for the composite transaction.
      *
      *@return long The time left before timeout.
      */
      
    public long getTimeOut();
    
//    /**
//     * Tests if the transaction should be an activity or not. 
//     * Note that this implies that either 
//     * ALL transactions in a propagation are activities 
//     * or NONE is. This makes sense because the
//     * propagation delimits the SCOPE of the distributed
//     * transaction, and this scope is either longer-lived 
//     * (activity) or 
//     * not, but never both. The scope inherently determines the
//     * moment at which termination is done via two-phase commit.
//     * 
//     * @return boolean True iff recoverable while active.
//     * 
//     */
//    public boolean isActivity();
}
